
/*
 * Programm zum Auslesen der Rohdaten 
 * für den HMC 5883L Kompassensor
 * Die Rohwerte der Achsen können über den seriellen Monitor
 * ausgegeben werden
 * Die Baud Rate des seriellen Monitor ist 9600
 */

 #include<Wire.h> // Bibliothek TWI Bus einbinden

 const byte AdresseHMC = 0x1E;     // Busadresse des HMC
 const byte HMCRegister = 0x02;    // Mode Register
 const byte HMCMessung = 0x00;     // Dauermessung
 const byte datenAusgang = 0x03;   // Daten Ausgang MSB Register Adresse

 // Variable festlegen
 int x=0;      // x-Achse
 int y=0;      // y-Achse
 int z=0;      // z-Achse

 void setup()
 {
  Serial.begin(9600);                 // Serielle Ausgabe über Monitor starten
  Wire.begin();                       // Buskomunikation starten
  Wire.beginTransmission(AdresseHMC); // Kommunikatio mit HMC starten
  Wire.write(HMCRegister);            // Modus Register wählen
  Wire.write(HMCMessung);             // Dauerhafte Messung starten
  Wire.endTransmission();             // Kommunikation beenden
 }
 void loop()
 {
  // Einlesen der Daten starten
  Wire.beginTransmission(AdresseHMC); // Buskommunikation starten
  Wire.write(datenAusgang);           // wähle MSB Register
  Wire.endTransmission();             // Kommunikation beenden

  // Alle Achsen einlesen
  Wire.requestFrom(AdresseHMC,6);
  if(6<=Wire.available())
  {
    x=Wire.read()<<8; // x-msb
    x|=Wire.read();   // x-lsb
    z=Wire.read()<<8; // y-msb
    z|=Wire.read();   // y-lsb
    y=Wire.read()<<8; // z-msb
    y|=Wire.read();   // z-lsb
  }
   // Werte der Achsen über Seriellen Monitor ausgeben
   Serial.print("xachse: ");
   Serial.print(x);
   Serial.print(" yachse: ");
   Serial.print(y);
   Serial.print(" zachse: ");
   Serial.println(z);
   delay(250);
 }

