/*
 * Programm zum Auslesen der Rohdaten 
 * für den MPU6050 Beschleunigungssensor
 * Die Rohwerte der Achsen können über den seriellen Monitor
 * ausgegeben werden
 * Die Baud Rate des seriellen Monitor ist 9600
 */

#include<Wire.h>
 
//Adresse Beschleunigungssensor (MPU6050) GY 571
const int MPU=0x68;  
 
//Variable
int ax;    // beschleunigung x achse
int ay;    // beschleunigung y achse
int az;    // beschleunigung z achse
int gx;    // kreisel x achse
int gy;    // kreisel y achse
int gz;    // kreisel z achse
int temp;  // temperatur
 
//------------------------------ Setup -------------------------------
void setup()
{
 
  Serial.begin(9600);           //Serieller Monitor sarten
  Wire.begin();                 //I2C Bus sarten
  Wire.beginTransmission(MPU);  //MPU Datenübertragung starten
  Wire.write(0x6B);             //Register setzen
   
  //Ini MPU-6050
  Wire.write(0); 
  Wire.endTransmission(true);
}
 

void loop()
{
  Wire.beginTransmission(MPU);      // Datenübertragung starten
  Wire.write(0x3B);                 // Register setzen
  Wire.endTransmission(false);      // Datenübertragung stoppen
  
  Wire.requestFrom(MPU,14,true);   
   // Achsen auslesen
  ax=Wire.read()<<8|Wire.read();    //0x3B      
  ay=Wire.read()<<8|Wire.read();    //0x3D 
  az=Wire.read()<<8|Wire.read();    //0x3F 
  temp=Wire.read()<<8|Wire.read();  //0x41 
  gx=Wire.read()<<8|Wire.read();    //0x43 
  gy=Wire.read()<<8|Wire.read();    //0x45 
  gz=Wire.read()<<8|Wire.read();    //0x47 
   
  Serial.print("Achse:"); 
  Serial.print("\tX: ");Serial.print(ax);
  Serial.print("\tY: ");Serial.print(ay);
  Serial.print("\tZ: ");Serial.print(az);
  
  Serial.print("\tKreisel:"); 
  Serial.print("\tX: ");Serial.print(gx);
  Serial.print("\tY: ");Serial.print(gy);
  Serial.print("\tZ: ");Serial.print(gz);
   
  Serial.print("\tTemperatur: ");    Serial.println(temp/340.00+36.53);
   
  delay(250);
}
