/*
 * Programm zum Auslesen der Rohdaten 
 * für den QMC 5883L Kompassensor
 * Die Rohwerte der Achsen können über den seriellen Monitor
 * ausgegeben werden
 * Die Baud Rate des seriellen Monitor ist 9600
 */

#include <Wire.h> //I2C Arduino Library

#define AdresseQMC 0x0D //I2C Adresse QMC
int x=0;  //x achse
int y=0;  //y achse
int z=0;  //z achse

void setup() 
{
  Serial.begin(9600);                 // Serielle Ausgabe über Monitor starten
  Wire.begin();                       // Buskomunikation starten
  
  Wire.beginTransmission(AdresseQMC); // Kommunikation mit QMC starten
  Wire.write(0x0B);                   // Dauerhafte Messung
  Wire.write(0x01);                   // Dauerhafte Messung
  Wire.endTransmission();
  Wire.beginTransmission(AdresseQMC); 
  Wire.write(0x09);                   // Mode Register wählen
  Wire.write(0x1D);                   // Register setzen
  Wire.endTransmission();             // Kommunikation beenden
}

void loop() 
{
 // Einlesen der Daten starten
  Wire.beginTransmission(AdresseQMC);
  Wire.write(0x00); //Datenausgabe msb Register
  Wire.endTransmission();

  //Alle Achsen einlesen
  Wire.requestFrom(AdresseQMC, 6);
  if (6 <= Wire.available()) {
    x = Wire.read();       //MSB  
    x |= Wire.read() << 8; //LSB  
    y = Wire.read();       //MSB  
    y |= Wire.read() << 8; //LSB 
    z = Wire.read();       //MSB 
    z |= Wire.read() << 8; //LSB 
  }

  // Werte der Achsen über Seriellen Monitor ausgeben
  Serial.print("xachse: ");
  Serial.print(x);
  Serial.print("  yachse: ");
  Serial.print(y);
  Serial.print("  zachse: ");
  Serial.println(z);
  delay(250);
}
